﻿using System;

namespace SmallInjectorDemo
{
    internal static class Program
    {
        private static void Main()
        {
            Console.WriteLine("Small dependency injection example");
            var injector = new SmallInjector();
            Console.WriteLine("Register " + nameof(SystemClock));
            injector.RegisterType<SystemClock, IClock>(true);
            Console.WriteLine("Register " + nameof(ServiceOne));
            injector.RegisterType<ServiceOne, IServiceOne>(true);
            Console.WriteLine("Register " + nameof(ServiceTwo));
            injector.RegisterType<ServiceTwo, IServiceTwo>(true);
            Console.WriteLine("Register " + nameof(ServiceConsumer));
            injector.RegisterType<ServiceConsumer>(false);

            Console.WriteLine();
            Console.WriteLine("Resolve class instances:");
            var useful1 = injector.Resolve<ServiceConsumer>();
            var useful2 = injector.Resolve<ServiceConsumer>();
            var useful3 = injector.Resolve<ServiceConsumer>();
            Console.WriteLine();
            Console.WriteLine("Run test methods:");
            useful1.TestTheServices();
            Console.WriteLine();
            useful2.TestTheServices();
            Console.WriteLine();
            useful3.TestTheServices();
            Console.ReadLine();
        }
    }
}